#This Plesk mk-file. Need for using portupgrade for update and install standart packages 
#from ports. Packages may be installed from various repositories (defined in portupgrade's
# config file.
#Target may be redefined in Makefile of port. Definiton some targets must to be before 
#include this file.
#

.if !defined(_PREMKINCLUDED)
.include <bsd.port.pre.mk>
.endif

#-----------------------------------------------------------------------------------------
# Variables
#-----------------------------------------------------------------------------------------
OWN_SITE=http://www.swsoft.com

SW_CATEGORY= swsoft
VALID_CATEGORIES+= ${SW_CATEGORY} 

PKG_DEINSTALL?=${TOOLS_DIR}/pkg_deinstall
PORTUPGRADE?=${LOCALBASE}/sbin/portupgrade
PORTUPGRADE_PORT?=ports-mgmt/portupgrade

PACKAGE_INSTALLDIR?= ${LOCALBASE}
SW_WRKDIR= ${PORTSDIR}/${SW_CATEGORY}/work
TOOLS_DIR=${LOCALBASE}/sbin
PKG_DB_DIR?= /var/db/pkg

.if ${MASTERDIR} != ${.CURDIR}
PKGORIGIN= ${MASTER_PORT}
.endif

PKGTOOLS_CONF?= ${LOCALBASE}/etc/pkgtools.conf.swsoft
LOG_FILE=/tmp/portupgrade-%s::%s.log
INSTALL_FILE=${WRKDIR}/.install.${PORTNAME}
INSTALLED_FILE=${SW_WRKDIR}/.installed.${PORTNAME}
CHECKED_FILE=${WRKDIR}/.checked.${PORTNAME}

.if !defined(FETCHDIR)
FETCHDIR= ${DISTDIR}
.endif

PORTUPGRADE_FLAGS= -O -N -w -W -L ${LOG_FILE} 

.if defined(VERBOSE) || defined(PLESK_INSTALLER_DEBUG)
VERBOSE_FLAG=1
PORTUPGRADE_FLAGS+= --verbose
.else
VERBOSE_FLAG=
.endif

_PRE_DEPENDS= ${PORTUPGRADE_PORT}
_PRE_CONFLICTS=

SED_ENV+= \
	-e 's|%D|${PACKAGE_INSTALLDIR}|g' \
	-e 's|^\@exec \(.*\)|\"\1\"|g'

.if !defined(USE_NATIVE_MK)
#-----------------------------------------------------------------------------------------
# Main targets
#-----------------------------------------------------------------------------------------
.if !defined(NO_CHECKSUM) && !defined(NO_EXTRACT)
pre-fetch: 
	@file=$$(${MD5} ${DISTDIR}/${DISTFILES} | ${AWK} -F '=' '{print $$2}') && \
	sum=$$(${CAT} ${MD5_FILE} | ${GREP} ${DISTFILES} | ${AWK} -F '=' '{print $$2}') && \
	if [ "X$$sum" != "X$$file" ]; then \
		${ECHO} "${DISTFILES} was to be refetch"; \
		${RM} -f ${DISTDIR}/${DISTFILES}; \
	fi
.else
pre-fetch: 
	@${MKDIR} ${.CURDIR}/work
.endif

#-----------------------------------------------------------------------------------------
pre-extract: do-index

.if !target(do-extract) && defined(NO_EXTRACT)
do-extract:
	@${MKDIR} ${WRKSRC}
.endif

#Configure 
#-----------------------------------------------------------------------------------------
.if defined(NO_CONFIGURE)
configure: extract
.endif

#Build targets block
#-----------------------------------------------------------------------------------------
.if !defined(NO_BUILD)

.if !target(build)
build: configure pre-build 
	@${TOUCH} ${TOUCH_FLAGS} ${BUILD_COOKIE}
.endif

.if !target(do-build)
do-build:
.endif

.endif #NO_BUILD

#Install targets block
#-----------------------------------------------------------------------------------------
.if !defined(NO_INSTALL)

pre-install:

.if !target(do-install)
do-install: do-install-pre do-install-now do-exec do-install-post
 
do-install-pre:
. if !defined(NO_SCRIPTS)
	@PLESK_INSTALLER_DEBUG=${VERBOSE_FLAG} \
		${SH} ${PKGINSTALL} ${PKGNAME} PRE-INSTALL
. endif

.if !target(do-install-now)
do-install-now:
. if !defined(NO_EXTRACT) && !defined(NO_INSTALL)
	@echo -n "---> Copying files into installation directory... "
	@${CP} -RPf ${WRKSRC}/* ${PACKAGE_INSTALLDIR}/	
	@echo "done"
.endif
.endif

do-install-post:
. if !defined(NO_SCRIPTS)
	@PLESK_INSTALLER_DEBUG=${VERBOSE_FLAG} \
		${SH} ${PKGINSTALL} ${PKGNAME} POST-INSTALL
. endif
.endif

.endif

.endif # USE_NATIVE_MK 

#------------------------------------------------------------------------------------------
# Target empty for compatibility with previous versions. 
#------------------------------------------------------------------------------------------
all-conflicts:

.if !target(product-pre-cmd)
product-pre-cmd:
	@echo "===> Checking ports marked as BROKEN or IGNORE"
	@depends=$$(${MAKE} all-depends-list | sed -e 's|${PORTSDIR}/||g'); \
	for dep in $$depends ${PKGORIGIN}; do \
	    _test_cmd=$$(cd ${PORTSDIR}/$$dep && ${MAKE} -V FORBIDDEN); \
	    if [ ! -z "$$_test_cmd" ]; then \
		forbidden="$$forbidden $$dep"; \
	    fi; \
	    _test_cmd=$$(cd ${PORTSDIR}/$$dep && ${MAKE} -V IGNORE); \
	    if [ ! -z "$$_test_cmd" ]; then \
		ignored="$$ignored $$dep"; \
	    fi; \
	done; \
	if [ ! -z "$$ignored" ]; then \
	    echo "Warning: Follow ports mark as ignored but was installed now:"; \
	    for i in $$ignored; do \
		echo "   $$dep: $$(cd ${PORTSDIR}/$$dep && ${MAKE} -V IGNORE)"; \
	    done; \
	    echo ""; \
	fi; \
	if [ ! -z "$$forbidden" ]; then \
	    echo "ERROR!!!: Follow ports mark as FORBIDDEN:"; \
	    for i in $$forbidden; do \
		echo "   $$dep: $$(cd ${PORTSDIR}/$$dep && ${MAKE} -V FORBIDDEN)"; \
	    done; \
	    echo ""; \
	    echo "Installation failed"; \
	    echo "Please use ports with another tag or use ports distributed by SwSoft."; \
	    exit 1; \
	fi
.endif

.if !target(product-post-cmd)
product-post-cmd:
.endif

#------------------------------------------------------------------------------------------
# Execute commands before main resolve depends/conflicts
#------------------------------------------------------------------------------------------
.if !target(sw-pre-cmd)
sw-pre-cmd: sw-pre-fetch sw-pre-conflicts sw-pre-depends
.endif

.if !target(sw-pre-fetch)
sw-pre-fetch:
.   if defined(FETCH_SITES_LIST) && defined(FETCH_FILES_LIST) 
.      for _list in ${FETCH_SITES_LIST}
.        for _files in ${FETCH_FILES_LIST}
.	     if !exists(${FETCHDIR}/${_files})
		@cd ${FETCHDIR} && /usr/bin/fetch -FR ${_list}/${_files} || continue
.            endif
.        endfor
.      endfor
.   endif
.endif

.if !target(sw-pre-conflicts)
sw-pre-conflicts:
	@echo "==> Deinstall pre-conflicts for: ${PKGNAME}"
	@depends=$$(${MAKE} all-depends-list | grep ${SW_CATEGORY} || true); \
	for dep in "${PORTSDIR}/${_PRE_CONFLICTS}" $$depends "${PORTSDIR}/${PKGORIGIN}"; do \
	    pre_conflict=$$(cd $$dep && ${MAKE} -V PRE_CONFLICTS); \
	    if [ ! -z "$$pre_conflict" ]; then \
		pre_conflicts="$$pre_conflicts $$pre_conflict"; \
	    fi; \
	done; \
	if [ ! -z "$$pre_conflicts" ]; then \
	    PKGTOOLS_CONF=${PKGTOOLS_CONF} \
		${PKG_DEINSTALL} -O -P -f $$pre_conflicts 2>/dev/null || true; \
	    for i in $$pre_conflicts; do \
		name="$${i##*/}"; \
		rm -f ${SW_WRKDIR}/.installed.$$name; \
	    done; \
	fi
.endif

.if !defined(NO_PRE_DEPENDS)
.if !target(sw-pre-depends)
sw-pre-depends:
	@echo "==> Install pre-depends for: ${PKGNAME}"
	@depends=$$(${MAKE} all-depends-list | grep ${SW_CATEGORY} || true); \
	for dep in $$depends "${PORTSDIR}/${PKGORIGIN}"; do \
	    name="$${dep##*/}"; \
	    if [ ! -f "${SW_WRKDIR}/.installed.$$name" ]; then \
		pre_depend=$$(cd $$dep && ${MAKE} -V PRE_DEPENDS); \
		if [ ! -z "$$pre_depend" ]; then \
		    for i in $$pre_depend; do \
			master_origin=$$(cd ${PORTSDIR}/$$i && ${MAKE} -V PKGORIGIN); \
			_installed=$$(pkg_info -qO $$master_origin); \
			if [ -z "$$_installed" ]; then \
			    pre_depends="$$pre_depends $$i"; \
			fi; \
		    done; \
		fi; \
	    fi; \
	done; \
	if [ ! -z "$$pre_depends" ]; then \
	    ${MAKE} -DSW_PRE_DEPENDS DEPENDS="$$pre_depends" sw-install-depends; \
	    for i in $$pre_depends; do \
                conflicts=$$(cd ${PORTSDIR}/$$i && ${MAKE} -V CONFLICTS); \
                if [ "X$$conflicts" != "X" ]; then \
		    PKGTOOLS_CONF=${PKGTOOLS_CONF} \
		    ${PKG_DEINSTALL} -O -P -f $$conflicts 2>/dev/null || true; \
		    for confl in $$conflict; do \
			name="$${confl##*/}"; \
			rm -f ${SW_WRKDIR}/.installed.$$name; \
		    done; \
		fi; \
		NO_SW_DEPENDS=1 \
		PKGTOOLS_CONF=${PKGTOOLS_CONF} \
		    ${PORTUPGRADE} ${PORTUPGRADE_FLAGS} -P $$i; \
	    done; \
	fi
.endif
.else
sw-pre-depends:
.endif

#------------------------------------------------------------------------------------------
# Install and upgrade all depends
#------------------------------------------------------------------------------------------
.if !defined(NO_SW_DEPENDS)
sw-install-depends: 
.if defined(SW_PRE_DEPENDS)
	    @${MAKE} -DSW_PRE_DEPENDS DEPENDS="${DEPENDS}" sw-depends
.else
	    @${MAKE} sw-depends
.endif
	    @for i in $$(cat ${INSTALL_FILE} 2>/dev/null); do \
		echo "----> $$i"; \
		conflicts=$$(cd ${PORTSDIR}/$$i && ${MAKE} -V CONFLICTS); \
		if [ "X$$conflicts" != "X" ]; then \
		PKGTOOLS_CONF=${PKGTOOLS_CONF} \
		    ${PKG_DEINSTALL} -O -P -f $$conflicts 2>/dev/null || true; \
		    for confl in $$conflict; do \
			name="$${confl##*/}"; \
			rm -f ${SW_WRKDIR}/.installed.$$name; \
		    done; \
		fi; \
	        NO_SW_DEPENDS=1 \
	        PKGTOOLS_CONF=${PKGTOOLS_CONF} \
		   ${PORTUPGRADE} ${PORTUPGRADE_FLAGS} -P $$i; \
		name="$${i##*/}"; \
		installed=$$(PKGTOOLS_CONF=${PKGTOOLS_CONF} portversion -O $$i | awk '{print $$2}'); \
		if [ "$$installed" = '=' ]; then \
		    ${TOUCH} ${SW_WRKDIR}/.installed.$$name; \
		fi; \
	    done

# 1. configured options already in variables WITH_*, WITHOUT_*
# 2. redefine default or selected options with options from make.conf
# 3. options from make.conf has priority
sw-install-options:
	@echo "===> Set options for all dependencies"
	@for deps in $$(${MAKE} all-depends-list | sed -e 's|${PORTSDIR}/||g') ${PKGORIGIN}; do \
	    opts=$$(cd ${PORTSDIR}/$$deps && make -V OPTIONS:C/\".*\"/=/g); \
	    if [ ! -z "$$opts" ]; then \
		optionsfile=$$(cd ${PORTSDIR}/$$deps && ${MAKE} -V OPTIONSFILE); \
		if [ ! -f "$$optionsfile" ]; then \
		    ${MKDIR} -p $${optionsfile%/*}; \
		    opts=$$(echo $$opts | sed -e 's|[Oo][Nn]|true\||g' -e 's|[Oo][Ff][Ff]|\||g'  \
							-e 's|[[:space:]]||g' -e 's|\|| |g'); \
		    pkgname=$$(cd ${PORTSDIR}/$$deps && ${MAKE} -V PKGNAME); \
		    echo "_OPTIONS_READ=$$pkgname" > $$optionsfile; \
		    for opt in $$opts; do \
			_var="$${opt%=*}"; \
			_res=$$(cd ${PORTSDIR}/$$deps && ${MAKE} -V WITH_$$_var); \
			if [ ! -z "$$_res" ]; then  \
			    echo "WITH_$${_var}=true" >> $$optionsfile; \
			else \
			    echo "WITHOUT_$${_var}=true" >> $$optionsfile; \
			fi; \
		    done; \
		fi; \
	    fi; \
	    echo -n "."; \
	done
	@echo;

.else
sw-install-depends: 

sw-install-options:
.endif

sw-update-db:
	@PKGTOOLS_CONF=${PKGTOOLS_CONF} \
	    pkgdb -aFu

#------------------------------------------------------------------------------------------
# Depends Core
#------------------------------------------------------------------------------------------
# Check depends
# Get plain sorted list of dependencies.
# And deinstall packages which not consistent or invalid.
# As result - sorted dependenices list which need install/upgrade and 
# without already installed components

.if !defined(NO_SW_DEPENDS)
sw-depends: 
	@echo "---> Create list of dependencies"
	@mkdir -p ${WRKDIR}
	@mkdir -p ${SW_WRKDIR}
	@rm -f ${CHECKED_FILE} && ${TOUCH} ${CHECKED_FILE}
.if defined(SW_PRE_DEPENDS)
	@${MAKE} DEPENDS="${DEPENDS}" sw-depends-req
.else
	@depends=$$(${MAKE} -V _DEPEND_DIRS | sed -e 's|${PORTSDIR}/||g'); \
	${MAKE} DEPENDS="$$depends" sw-depends-req
.endif
	@cat ${CHECKED_FILE} | sort -nr | \
		awk '{ split($$2,x,"/"); if ( dep[x[2]] == 1) { next; } else { print $$2; dep[x[2]] = 1; } }' \
		> ${INSTALL_FILE}.tmp
	@echo ""
.if defined(SW_PRE_DEPENDS)
	@${MAKE} ADD_DEPEND="${DEPENDS}" sw-invalid-pkg
.else
	@${MAKE} ADD_DEPEND="${PKGORIGIN}" sw-invalid-pkg
.endif
	@cat ${INSTALL_FILE} | awk '{ \
	    mas[NR] = $$1; \
	    for(i=0; i<=NR; i++){ \
		if (mas[i] == $$2) { \
		    mas[i] = $$1; \
		} \
	    } \
	} \
	END { \
	    for(i=0; i<=NR; i++) { \
		if (dep[mas[i]] != 1) {  \
		    print(mas[i]); \
		    dep[mas[i]] = 1; \
		} \
	    } \
	}' > ${INSTALL_FILE}.tmp 
	@cp -f ${INSTALL_FILE}.tmp ${INSTALL_FILE}

.else
sw-depends:
.endif

# Reqursive part
sw-depends-req:
	@for i in ${DEPENDS}; do \
	    if [ "$$__MKLVL__" = "20" ]; then \
		echo "Very deep recursion"; \
		exit 1; \
	    fi; \
	    sw_checked=$$(cat ${CHECKED_FILE} | \
		awk -v var1=$$__MKLVL__ -v var2=$$i '{if ($$1 == var1 && $$2 ==var2) { print $$1 ;}}'); \
	    if [ "X$$sw_checked" = "X" ]; then \
		name="$${i##*/}"; \
		if [ ! -f "${SW_WRKDIR}/.installed.$$name" ]; then \
		    echo "$$__MKLVL__ $$i" >> ${CHECKED_FILE}; \
		    depends=$$(cd ${PORTSDIR}/$$i && ${MAKE} -V _DEPEND_DIRS | sed -e 's|${PORTSDIR}/||g'); \
		    ${MAKE} DEPENDS="$$depends" sw-depends-req; \
		fi; \
	    fi; \
	    echo -n '.'; \
	done

# Deinstall invalid packages
# If package version above or equal existing in ports tree.
# and depended file not in system - delete package
#-----------------------------------------------------------------------------------------
sw-invalid-pkg:
	@echo "---> Check packages which exists in system"
	@rm -f ${CHECKED_FILE} && ${TOUCH} ${CHECKED_FILE}
	@rm -f ${INSTALL_FILE} && ${TOUCH} ${INSTALL_FILE}
	@checklist=''; \
	for dep in $$(cat ${INSTALL_FILE}.tmp) ${ADD_DEPEND}; do \
	    for i in $$(cd ${PORTSDIR}/$$dep && ${MAKE} -V LIB_DEPENDS | xargs echo -n); do \
		portpath="$${i#*:}"; \
		sw_checked=$$(cat ${CHECKED_FILE} | awk -v var=$$i '{if ($$1 == var) {print $$1;}}'); \
		if [ "X$$sw_checked" = "X" ]; then \
		    master_origin=$$(cd $$portpath && ${MAKE} -V PKGORIGIN); \
		    origin=$$(echo $$portpath | sed -e 's|${PORTSDIR}/||g'); \
		    installed=$$(PKGTOOLS_CONF=${PKGTOOLS_CONF} portversion -O $$master_origin 2>/dev/null | awk '{print $$2}'); \
		    if [ "$$installed" = '=' -o "$$installed" = '>' ]; then \
			lib=$${i%%:*}; \
			case $$lib in \
			    *.*.*)  pattern="`${ECHO_CMD} $$lib | ${SED} -e 's/\./\\\\./g'`" ;;\
			    *.*)    pattern="$${lib%%.*}\.$${lib#*.}" ;;\
			    *)  pattern="$$lib" ;;\
			esac; \
			if ${LDCONFIG} -r | ${GREP} -vwF -e "${PKGCOMPATDIR}" | ${GREP} -qwE -e "-l$$pattern"; then \
				found=1; \
			    else \
				found=0; \
			fi; \
			if [ $$found = 0 ]; then \
			    checklist="$$checklist $$master_origin"; \
			    echo "$$origin $$master_origin" >> ${INSTALL_FILE}; \
			fi; \
		    else \
			echo "$$origin $$master_origin" >> ${INSTALL_FILE}; \
		    fi; \
		    echo "$$i" >> ${CHECKED_FILE}; \
		fi; \
	    done; \
	    for i in $$(cd ${PORTSDIR}/$$dep && ${MAKE} -V RUN_DEPENDS -V BUILD_DEPENDS | xargs echo -n); do \
		portpath="$${i#*:}"; \
		sw_checked=$$(cat ${CHECKED_FILE} | awk -v var=$$i '{if ($$1 == var) {print $$1;}}'); \
		if [ "X$$sw_checked" = "X" ]; then \
		    master_origin=$$(cd $$portpath && ${MAKE} -V PKGORIGIN); \
		    origin=$$(echo $$portpath | sed -e 's|${PORTSDIR}/||g'); \
		    installed=$$(PKGTOOLS_CONF=${PKGTOOLS_CONF} portversion -O $$master_origin 2>/dev/null | awk '{print $$2}'); \
		    if [ "$$installed" = '=' -o "$$installed" = '>' ]; then \
			prog=$${i%%:*}; \
			if ${EXPR} "$$prog" : \\/ >/dev/null; then \
			    if [ -e "$$prog" ]; then \
				found=1; \
			    else \
				found=0; \
			    fi; \
			else \
			    prog=$$(echo $$prog | sed -e 's/[<|>|=].*//g'); \
			    if ${WHICH} "$$prog" > /dev/null 2>&1 ; then \
				found=1; \
			    else \
				found=0; \
			    fi; \
			fi; \
			if [ $$found = 0 ]; then \
			    checklist="$$checklist $$master_origin"; \
			    echo "$$origin $$master_origin" >> ${INSTALL_FILE}; \
			fi; \
		    else \
			echo "$$origin $$master_origin" >> ${INSTALL_FILE}; \
		    fi; \
		    echo "$$i" >> ${CHECKED_FILE}; \
		fi; \
	    done; \
	    echo -n '.'; \
	done; \
	echo ""; \
	if [ "X$$checklist" != "X" ]; then \
	    PKGTOOLS_CONF=${PKGTOOLS_CONF} \
		${PKG_DEINSTALL} -O -P -f $$checklist 2>/dev/null || true; \
	    for i in $$checklist; do \
		name="$${i##*/}"; \
		rm -f ${SW_WRKDIR}/.installed.$$name; \
	    done; \
	fi

#-------------------------------------------------------------------------------------------
# Set correct permissions 
#-------------------------------------------------------------------------------------------
EXEC_LIST!= [ -f ${.CURDIR}/pkg-plist ] && cat ${.CURDIR}/pkg-plist | grep '@exec ' | sed ${SED_ENV} || true

.if !target(do-exec)
do-exec:
	@for CMD in ${EXEC_LIST}; do \
		${SH} -c "$$CMD"; \
	done
.endif

#-------------------------------------------------------------------------------------------
# Error processing
#-------------------------------------------------------------------------------------------
do-error:
		@echo "Unable to install some components"
		@exit 1

#-------------------------------------------------------------------------------------------
# Indexes
#-------------------------------------------------------------------------------------------
do-index:
	@describe=$$(${MAKE} describe); \
	if [ "X$$describe" != "X" ]; then \
		origin=$$(echo $$describe | awk -F '|' '{print $$2}'| sed -e 's|^${PORTSDIR}/\(.*\)|\1|g'); \
		portname=$$(echo $$describe | awk -F '|' '{print $$1}'| sed -e 's|\(.*\)\-[[:digit:]]*.*|\1|g'); \
		if ! ${GREP} -q "^$$portname-[[:digit:]]" ${INDEXDIR}/${INDEXFILE} > /dev/null; then \
			echo $$describe >> ${INDEXDIR}/${INDEXFILE}; \
		else \
			sed -i "" -e "s#^$$portname-[[:digit:]]\(.*\)|${PORTSDIR}/$$origin\|\(.*\)#$$describe#" ${INDEXDIR}/${INDEXFILE}; \
		fi; \
	else \
.               error "Inconsistent port"; \
	fi

index: do-index


#<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.if !defined(_POSTMKINCLUDED)
.include <bsd.port.post.mk>
.endif 

.if defined(USE_PHP)
.include "${PORTSDIR}/Mk/bsd.php.mk"
.endif

#<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
sw-install-check:

sw-install: sw-install-options sw-pre-cmd 
	@conflicts=$$(${MAKE} -V CONFLICTS); \
	if [ "X$$conflicts" != "X" ]; then \
	    PKGTOOLS_CONF=${PKGTOOLS_CONF} \
		${PKG_DEINSTALL} -O -P -f $$conflicts 2>/dev/null || true; \
	    for i in $$conflict; do \
		name="$${i##*/}"; \
		rm -f ${SW_WRKDIR}/.installed.$$name; \
	    done; \
	fi; \
	${MAKE} sw-install-depends; \
	NO_SW_DEPENDS=1 \
	PKGTOOLS_CONF=${PKGTOOLS_CONF} \
	    ${PORTUPGRADE} ${PORTUPGRADE_FLAGS} ${PKGORIGIN}; \
	${MAKE} sw-update-db; \
	installed=$$(PKGTOOLS_CONF=${PKGTOOLS_CONF} portversion -O ${PKGORIGIN} 2>/dev/null | awk '{print $$2}'); \
	if [ "$$installed" = '=' ]; then \
	    ${TOUCH} ${INSTALLED_FILE}; \
	fi

